/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahlvorschlag.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="REFERENDUM_OPTION.UK",
     query="SELECT o FROM ReferendumOption o WHERE "

                         + "o"
                +".discriminator"
              +" = ?1"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".nummer"
              +" = ?2"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".gebietsart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".gebietsart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?5"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?6"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?7"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?8"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?9"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".wahltermin"
                +".nummer"
              +" = ?10"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".wahltermin"
                +".wahldatum"
              +" = ?11"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gebiet"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?12"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gruppe"
                +".schluessel"
              +" = ?13"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gruppe"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?14"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gruppe"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?15"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?16"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?17"

             +" AND "         + "o"
                +".gruppeImGebiet"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?18"

             +" AND "         + "o"
                +".position"
              +" = ?19"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="REFERENDUM_OPTION.ReferendumVorlageImGebietAndPosition",
     query="SELECT obj FROM ReferendumOption obj WHERE obj.gruppeImGebiet = ?1 AND obj.position = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="REFERENDUM_OPTION.Wahl",
     query="SELECT o FROM ReferendumOption o WHERE o.gruppeImGebiet.gruppe.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "REFERENDUM_OPTION")
@javax.persistence.Cacheable
@javax.persistence.PrimaryKeyJoinColumn(name="wahlvorschlag_id")
@javax.persistence.DiscriminatorValue(ReferendumOption.DISCRIMINATOR_VALUE)

public
 class ReferendumOption
extends AbstractReferendumOption
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "REFERENDUM_OPTION";

  /**
   * default constructor
   */
  public ReferendumOption() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public ReferendumOption(ReferendumOption original){
      original.copyEntity(this);
    }


  @Override
  public void resetAttributeChanged() {
        hasChangedKurzbezeichnung = false;
          hasChangedLabel = false;
          hasChangedPosition = false;
  


        
    super.resetAttributeChanged();
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "KURZBEZEICHNUNG", nullable = ReferendumOptionConstants.KURZBEZEICHNUNG_NULLABLE, length=ReferendumOptionConstants.KURZBEZEICHNUNG_MAX_LENGTH)
        
  protected java.lang.String kurzbezeichnung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedKurzbezeichnung = false;

  public boolean hasChangedKurzbezeichnung(){
    return hasChangedKurzbezeichnung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertKurzbezeichnung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenKurzbezeichnung;
  
  /**
   * 
   *
   * getter for REFERENDUM_OPTION.KURZBEZEICHNUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getKurzbezeichnung() {
        return kurzbezeichnung;
      }

  /**
   * 
   *
   * setter for REFERENDUM_OPTION.KURZBEZEICHNUNG
   *
   * @param kurzbezeichnung
   */
  @Override   public void setKurzbezeichnung(@javax.annotation.Nullable  java.lang.String kurzbezeichnung) {

       resetTkCache();
                  
                          java.lang.String kurzbezeichnungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(kurzbezeichnung, ReferendumOptionConstants.KURZBEZEICHNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.kurzbezeichnung
      , kurzbezeichnungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedKurzbezeichnung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("kurzbezeichnung");
      }


             if (!isSeitLadenVeraendertKurzbezeichnung) {
          isSeitLadenVeraendertKurzbezeichnung = thisAttributChanged;
         if (isSeitLadenVeraendertKurzbezeichnung){
           wertNachLadenKurzbezeichnung=this.kurzbezeichnung;
         }
       }
      

       this.kurzbezeichnung = kurzbezeichnungInternal;

         }

        
      @javax.persistence.Column(name = "LABEL", nullable = ReferendumOptionConstants.LABEL_NULLABLE, length=ReferendumOptionConstants.LABEL_MAX_LENGTH)
        
  protected java.lang.String label =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLabel = false;

  public boolean hasChangedLabel(){
    return hasChangedLabel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertLabel = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenLabel;
  
  /**
   * 
   *
   * getter for REFERENDUM_OPTION.LABEL
   */
    @Override   public  java.lang.String getLabel() {
        return label;
      }

  /**
   * 
   *
   * setter for REFERENDUM_OPTION.LABEL
   *
   * @param label
   */
  @Override   public void setLabel( java.lang.String label) {

       resetTkCache();
                  
                          java.lang.String labelInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(label, ReferendumOptionConstants.LABEL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.label
      , labelInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLabel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("label");
      }


             if (!isSeitLadenVeraendertLabel) {
          isSeitLadenVeraendertLabel = thisAttributChanged;
         if (isSeitLadenVeraendertLabel){
           wertNachLadenLabel=this.label;
         }
       }
      

       this.label = labelInternal;

         }

        
      @javax.persistence.Column(name = "POSITION", nullable = ReferendumOptionConstants.POSITION_NULLABLE, precision=ReferendumOptionConstants.POSITION_PRECISION, scale=ReferendumOptionConstants.POSITION_SCALE)
            
  protected java.lang.Long position =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPosition = false;

  public boolean hasChangedPosition(){
    return hasChangedPosition;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPosition = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenPosition;
  
  /**
   * 
   *
   * getter for REFERENDUM_OPTION.POSITION
   */
    @Override   public  java.lang.Long getPosition() {
        return position;
      }

  /**
   * 
   *
   * setter for REFERENDUM_OPTION.POSITION
   *
   * @param position
   */
  @Override   public void setPosition( java.lang.Long position) {

       resetTkCache();
                  java.lang.Long positionInternal = position;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.position
      , positionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPosition |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("position");
      }


             if (!isSeitLadenVeraendertPosition) {
          isSeitLadenVeraendertPosition = thisAttributChanged;
         if (isSeitLadenVeraendertPosition){
           wertNachLadenPosition=this.position;
         }
       }
      

       this.position = positionInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("ReferendumOption:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(ReferendumOption other){
        super.copyEntity(other);
                             other.kurzbezeichnung = this.kurzbezeichnung;
                                other.label = this.label;
                                other.position = this.position;
           


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(ReferendumOption.class)){
        copyEntityAttributesUsingSetter((ReferendumOption) other.castTo(ReferendumOption.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von ReferendumOption: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(ReferendumOption other){
      super.copyEntityAttributesUsingSetter(other);
               other.setKurzbezeichnung(this.kurzbezeichnung);
                  other.setLabel(this.label);
                  other.setPosition(this.position);
       
  }

    @Override
    public void copyEntityAttributesUsingSetter(de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag other){
       if (other.isInstanceOf(ReferendumOption.class)) {
         copyEntityAttributesUsingSetter(other.castTo(ReferendumOption.class).getEntity());
       } else {
         super.copyEntityAttributesUsingSetter(other);
       }
    }

  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(ReferendumOption other){
       super.copyChangedEntityAttributesUsingSetter(other);
                       if (hasChangedKurzbezeichnung) {
        other.setKurzbezeichnung(this.kurzbezeichnung);
      }
                             if (hasChangedLabel) {
        other.setLabel(this.label);
      }
                             if (hasChangedPosition) {
        other.setPosition(this.position);
      }
             }

    @Override
    public void copyChangedEntityAttributesUsingSetter(de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag other){
      if (other.isInstanceOf(ReferendumOption.class)) {
        copyChangedEntityAttributesUsingSetter(other.castTo(ReferendumOption.class).getEntity());
      } else {
        super.copyChangedEntityAttributesUsingSetter(other);
      }
    }




    @javax.persistence.Transient
    private transient ReferendumOptionTK tkCache;

    @Override
    protected void resetTkCache() {
    super.resetTkCache();
        tkCache = null;
    }

    public ReferendumOptionTK getReferendumOptionTK(){
    if (tkCache==null) {
    tkCache = new ReferendumOptionTK(

  (getGruppeImGebiet() == null) ? null : getGruppeImGebiet().getGruppeImGebietTK()
, getPosition()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getReferendumOptionTK();
    }

  @Override
  public ReferendumOptionUK getUk(){
    return getReferendumOptionUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return ReferendumOption.class;
  }

public ReferendumOptionUK getReferendumOptionUK(){

   return  new ReferendumOptionUK(

getDiscriminator()
,     getGruppeImGebiet()==null?null:getGruppeImGebiet().getGruppeImGebietUK()
, getPosition()


  );
}

  @javax.persistence.Transient
  private transient ReferendumOptionProperties properties;

  @Override
  public ReferendumOptionProperties getProperties(){
    if (properties == null) {
      properties = new ReferendumOptionProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ReferendumOptionProperties getReferendumOptionProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ReferendumOptionConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
        if (super.isAenderungenProtokollieren()){
      return true;
    }
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
            super.setProtokollierteAttributeMitWerten(werteVorher);
     
      if (werteVorher.containsKey(ReferendumOptionConstants.MESSAGE_KEY_KURZBEZEICHNUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ReferendumOptionConstants.MESSAGE_KEY_KURZBEZEICHNUNG_EINZAHL);

        kurzbezeichnung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(ReferendumOptionConstants.MESSAGE_KEY_LABEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ReferendumOptionConstants.MESSAGE_KEY_LABEL_EINZAHL);

        label =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(ReferendumOptionConstants.MESSAGE_KEY_POSITION_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ReferendumOptionConstants.MESSAGE_KEY_POSITION_EINZAHL);

        position =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = super.getProtokollierteAttributeMitWerten();
                        if (isSeitLadenVeraendertKurzbezeichnung) {
      result.put(ReferendumOptionConstants.MESSAGE_KEY_KURZBEZEICHNUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenKurzbezeichnung , kurzbezeichnung));
    }
                            if (isSeitLadenVeraendertLabel) {
      result.put(ReferendumOptionConstants.MESSAGE_KEY_LABEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenLabel , label));
    }
                            if (isSeitLadenVeraendertPosition) {
      result.put(ReferendumOptionConstants.MESSAGE_KEY_POSITION_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenPosition , position));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
        super.resetProtokollierteAttribute();
                      isSeitLadenVeraendertKurzbezeichnung = false;
      wertNachLadenKurzbezeichnung = null;
                          isSeitLadenVeraendertLabel = false;
      wertNachLadenLabel = null;
                          isSeitLadenVeraendertPosition = false;
      wertNachLadenPosition = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
           java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = super.getFachlichAbhaengigeEntitaeten();
            return result;
  }

        
            @Override
            protected String getInitialDiscriminator() {
              return "REFERENDUM_OPTION";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  @Override
  public boolean isPersistent() {
    return getId() != null;
  }



            
                  @Override
                public void resetValidation() {
                  super.resetValidation();
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                          @Override
                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                  validationResult.addAll(super.validateEntity());
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ReferendumOptionConstants.KURZBEZEICHNUNG_MAX_LENGTH ,  kurzbezeichnung, this, ReferendumOptionConstants.MESSAGE_KEY_KURZBEZEICHNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(label, this, ReferendumOptionConstants.MESSAGE_KEY_LABEL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ReferendumOptionConstants.LABEL_MAX_LENGTH , 1 ,  label, this, ReferendumOptionConstants.MESSAGE_KEY_LABEL_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(position, this, ReferendumOptionConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(ReferendumOptionConstants.POSITION_MAX_VALUE, ReferendumOptionConstants.POSITION_MIN_VALUE, position, this, ReferendumOptionConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            }
